<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ZooKeeperThread.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ZooKeeperThread.java</span></div><h1>ZooKeeperThread.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper.server;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This is the main class for catching all the uncaught exceptions thrown by the
 * threads.
 */
public class ZooKeeperThread extends Thread {

<span class="fc" id="L29">    private static final Logger LOG = LoggerFactory</span>
<span class="fc" id="L30">            .getLogger(ZooKeeperThread.class);</span>

<span class="fc" id="L32">    private UncaughtExceptionHandler uncaughtExceptionalHandler = new UncaughtExceptionHandler() {</span>

        @Override
        public void uncaughtException(Thread t, Throwable e) {
<span class="fc" id="L36">            handleException(t.getName(), e);</span>
<span class="fc" id="L37">        }</span>
    };

    public ZooKeeperThread(Runnable thread, String threadName) {
<span class="fc" id="L41">        super(thread, threadName);</span>
<span class="fc" id="L42">        setUncaughtExceptionHandler(uncaughtExceptionalHandler);</span>
<span class="fc" id="L43">    }</span>

    public ZooKeeperThread(String threadName) {
<span class="fc" id="L46">        super(threadName);</span>
<span class="fc" id="L47">        setUncaughtExceptionHandler(uncaughtExceptionalHandler);</span>
<span class="fc" id="L48">    }</span>

    /**
     * This will be used by the uncaught exception handler and just log a
     * warning message and return.
     * 
     * @param thName
     *            - thread name
     * @param e
     *            - exception object
     */
    protected void handleException(String thName, Throwable e) {
<span class="nc" id="L60">        LOG.warn(&quot;Exception occured from thread {}&quot;, thName, e);</span>
<span class="nc" id="L61">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>